import { AfterViewInit, Component, OnInit, ViewChild } from '@angular/core';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';

const DATA_EXAMPLE: Array<any> = [
  {
    NUMERO_PROBLEMA: '0000000001',
    TIPO_PROBLEMA: 'Producto Equivocado',
    NUMERO_ORDEN: '0000000001',
    DESCRIPCION: 'El producto fue enviado incorrecto',
    FECHA_REGISTRA: '2023-01-19 12:41:52',
    FECHA_MODIFICA: '2023-01-19 12:41:52',
    USUARIO_REGISTRA: 'Jean Jairo Benitez Meza',
    USUARIO_MODIFICA: 'Jean Jairo Benitez Meza',
    ESTADO: 'Activo',
  }
]


@Component({
  selector: 'app-issue-tracking',
  templateUrl: './issue-tracking.component.html',
  styleUrls: ['./issue-tracking.component.css']
})
export class IssueTrackingComponent implements AfterViewInit, OnInit {

  public displayedColumns: Array<string>;
  public dataSource: MatTableDataSource<any>;
  @ViewChild(MatPaginator) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;
  public txtBuscador:string;

  public isLoading: boolean;
  public isLoadingForm: boolean;
  public btnSmall: boolean;

  constructor() {
    this.displayedColumns = [ 'NUMERO_PROBLEMA', 'TIPO_PROBLEMA', 'NUMERO_ORDEN', 'DESCRIPCION', 'FECHA_REGISTRA', 'USUARIO_REGISTRA', 'ESTADO', 'ACCIONES' ];
    this.dataSource = new MatTableDataSource(DATA_EXAMPLE);
    this.isLoading = false;
    this.isLoadingForm = false;
    this.btnSmall = false;
    this.txtBuscador = '';
  }

  ngOnInit(): void {
  }

  ngAfterViewInit(): void {
    this.dataSource.paginator = this.paginator;
    this.dataSource.sort = this.sort;
  }

  // Método de filtrado de datos
  public applyFilter(event: any, type: string):void {
    let filterValue:string;
    if (type == 'INP') {
      filterValue = (event.target as HTMLInputElement).value;
    }else{
      this.txtBuscador = event;
      filterValue = event;
    }
    this.dataSource.filter = filterValue.trim().toLowerCase();
    if (this.dataSource.paginator) {
      this.dataSource.paginator.firstPage();
    }
  }

  // Método para reajustar los botones según sus dimensiones
  public onResize():void {
    this.btnSmall = window.innerWidth <= 1405;
  }

  // Método para dar formato a las fechas y horas
  public formatDate(dateRegister:string, dateUpdate:string | null):string {
    let date:string = (dateUpdate === null) ? dateRegister : dateUpdate;
    let arrDateTime:Array<string> = date.split(' ');
    let arrDate:Array<string> = arrDateTime[0].split('-');
    return `${arrDate[2]}-${arrDate[1]}-${arrDate[0]} ${arrDateTime[1]}`;
  }
}
